DECLARE SUB ShowSysSts (s AS INTEGER)
DECLARE SUB PrintBin (v AS INTEGER)
DECLARE SUB PrintMAG (n AS INTEGER)

DIM Loks(20, 2) AS INTEGER


CLS
PRINT "ICUM Events handling demo."
PRINT "(Note: this program only supports the RS-232 interface! No ISA-Bus.)"
PRINT
PRINT "COM Port (1 or 2, default = 1)"; : INPUT ; c$
IF c$ = "" THEN
    c$ = "1"
ELSEIF (c$ <> "1" AND c$ <> "2") THEN
    PRINT : PRINT "Error: only COM1 and COM2 are supported!"
END IF
c$ = "COM" + c$ + ":2400,N,8,2,CS10000,DS"
OPEN c$ FOR RANDOM AS #1
ON ERROR GOTO SerErr

PRINT : PRINT
PRINT "Events are polled every 0.1 Seconds."
PRINT "During program execution you can press:"
PRINT "- 'q' or <Esc> to end this program"
PRINT "- 's' to read the first 8 s88 Modules explicitly"

t = TIMER
PollTime = .1


EvtLoop:
u$ = UCASE$(INKEY$)
IF ((t + PollTime) > TIMER) AND u$ = "" THEN GOTO EvtLoop
t = TIMER
PRINT ".";

IF (u$ <> "Q") AND (u$ <> CHR$(27)) AND (u$ <> "S") THEN
    PRINT #1, "x"; CHR$(&HCC);
    a$ = INPUT$(1, #1)
    v% = ASC(a$)
    IF v% <> 0 THEN
        PRINT : PRINT "*** Event flags from cmd 204 (&hCC) = ";
        PRINT HEX$(ASC(a$))
    END IF
   
   
    IF (v% AND 1) = 1 THEN
        PRINT "New Lok(s) status detected:"
        PRINT #1, "x"; CHR$(&HCD);
        i = 0
        DO
            a$ = INPUT$(1, #1)
            n = ASC(a$)
            IF n <> 255 THEN
                i = i + 1
                Loks(i, 1) = n
                a$ = INPUT$(2, #1)
                Loks(i, 2) = ASC(a$)
            END IF
        LOOP UNTIL n = 255
       
        j = 0
        WHILE j < i
            j = j + 1
            SELECT CASE Loks(j, 1)  'Print controller identification
                CASE 129 TO 138
                    PRINT "C80(f)  #"; Loks(j, 1) - 128;
                CASE 139 TO 146
                    PRINT "LokMaus #"; Loks(j, 1) - 138;
                CASE ELSE
                    PRINT "Unknown #;Loks(j,1);"
            END SELECT
            PRINT " -> Lok #"; Loks(j, 2); ": ";
            PRINT #1, "x"; CHR$(&HCB); CHR$(Loks(j, 2));
            a$ = INPUT$(3, #1)
            B2 = ASC(MID$(a$, 2, 1))
            IF (B2 AND &H80) = &H80 THEN
                B1 = ASC(LEFT$(a$, 1))
                Speed = B1 AND &H7F
                PRINT "Speed= ";
                SELECT CASE Speed
                    CASE 0
                        PRINT "Stop";
                    CASE 1
                        PRINT "Dir Change/Em. Stop";
                    CASE ELSE
                        PRINT Speed - 1;
                END SELECT
                IF (B1 AND &H80) = 0 THEN Dir$ = "rev." ELSE Dir$ = "forw"
                PRINT ", Dir= "; Dir$;
                PRINT ", FL= "; B2 AND &H1;
                PRINT ", F1..8= "; : PrintBin ASC(RIGHT$(a$, 1))
                PRINT
            ELSE
                PRINT "(no Lok data!)"
            END IF
        WEND
    END IF
   
   
    IF (v% AND 2) = 2 THEN
        PRINT "Manual Mag command(s):"
        PRINT #1, "x"; CHR$(&HCE);
        DO
            a$ = INPUT$(1, #1)
            n = ASC(a$)
            IF n <> 255 THEN
                PRINT "Dec #"; n; ", Status= ";
                a$ = INPUT$(1, #1)
                s = ASC(a$)
                PRINT HEX$(s); "  (Ouputs #1..4=";
                PrintMAG (s AND &H1)
                PrintMAG ((s AND &H4) / &H4)
                PrintMAG ((s AND &H10) / &H10)
                PrintMAG ((s AND &H40) / &H40)
                PRINT ")"
            END IF
        LOOP UNTIL n = 255
    END IF
   
   
    IF (v% AND 4) = 4 THEN
        PRINT "s88 event(s):"
        PRINT #1, "x"; CHR$(&HCF);
        DO
            a$ = INPUT$(1, #1)
            n = ASC(a$)
            IF n <> 255 THEN
                PRINT "s88 #"; n; " ->  ";
                a$ = INPUT$(2, #1)
                PrintBin ASC(a$)
                PRINT " ";
                PrintBin ASC(RIGHT$(a$, 1))
                PRINT
            END IF
        LOOP UNTIL n = 255
    END IF
   
   
    IF (v% AND 8) = 8 THEN
        PRINT "There has been a Power Off."
        PRINT #1, "x"; CHR$(&HA2);
        a$ = INPUT$(1, #1)
        PRINT : PRINT "Current ICUM status: "; : PrintBin ASC(a$)
        PRINT ", i.e.:"
        ShowSysSts ASC(a$)
        PRINT
    END IF
   
    IF (v% AND &H10) = &H10 THEN
        PRINT "Attempt at switching 'busy' (reserved) accessories!"
    END IF
   
    IF (v% AND &HE0) <> 0 THEN
        PRINT "Unsupported/undocumented event flag."
    END IF
END IF

IF u$ = "S" THEN
    PRINT : PRINT "Reading first 8 s88 modules:"
    PRINT #1, CHR$(&H88);
    FOR i = 1 TO 8
        PRINT USING "##"; i;
        PRINT ": ";
        B$ = INPUT$(1, #1)
        PrintBin ASC(B$)
        PRINT " ";
        B$ = INPUT$(1, #1)
        PrintBin ASC(B$)
        PRINT
    NEXT
END IF

IF (u$ <> "Q") AND (u$ <> CHR$(27)) THEN GOTO EvtLoop

CLOSE
SYSTEM
END

SerErr:
IF ERR = 24 THEN    'I.e. if a device timeout error
    PRINT : PRINT "Waiting for 'RT' cmd (P50X ASCII) timeout...": PRINT
    RESUME
ELSE
    PRINT : PRINT "Error "; ERR: STOP
END IF

SUB PrintBin (v AS INTEGER)
DIM m AS INTEGER
m = 128
FOR i = 1 TO 8
   IF v AND m THEN f = 1 ELSE f = 0
   PRINT RIGHT$(STR$(f), 1);
   m = m / 2
NEXT
END SUB

SUB PrintMAG (n AS INTEGER)
IF n = 0 THEN PRINT " red";  ELSE PRINT " green";
END SUB

SUB ShowSysSts (s AS INTEGER)
IF (s AND &H80) <> 0 THEN
    PRINT "P50X only"
ELSE
    PRINT "Both P50 and P50X"
END IF
IF (s AND &H40) <> 0 THEN
    PRINT "Halt mode"
ELSE
    PRINT "Normal mode (not halted)"
END IF
IF (s AND &H20) <> 0 THEN
    PRINT "ICUM in slave mode (with external CU)"
ELSE
    PRINT "ICUM in master mode"
END IF
IF (s AND &H10) <> 0 THEN
    PRINT "VI2C is on"
ELSE
    PRINT "VI2C is off"
END IF
IF (s AND &H8) <> 0 THEN
    PRINT "Power On (Go)"
ELSE
    PRINT "Power Off (Stop)"
END IF
IF (s AND &H4) <> 0 THEN
    PRINT "No short detected"
ELSE
    PRINT "Short detected!"
END IF
IF (s AND &H2) <> 0 THEN
    PRINT "A 'Go' key is pressed"
ELSE
    PRINT "No 'Go' keys are pressed"
END IF
IF (s AND &H1) <> 0 THEN
    PRINT "A 'Stop' key is pressed"
ELSE
    PRINT "No 'Stop' keys are pressed"
END IF
END SUB

